package com.malk.service.dingtalk;

import java.util.List;
import java.util.Map;

public interface DDClient {

    /**
     * 获取访问授权
     */
    String getAccessToken();

    String getAccessToken(String appKey, String appSecret);

    /**
     * token授权参数: 旧版本
     */
    Map initTokenParams();

    /**
     * token授权参数: 新版本
     */
    Map initTokenHeader();

    /**
     * 上传审批附件
     *
     * @param urlFile      远程文件地址
     * @param fileNamePure 文件名称[后缀自动通过地址获取]
     */
    Map uploadFileFormUrl(String accessToken, String userId, String urlFile, String fileNamePure);

    Map uploadFileFormUrl(String accessToken, String userId, String filePath);

    /**
     * 获取审批实例ID列表_全部 [若轮询, 时间需要覆盖]
     *
     * @param startTime 审批实例开始时间，Unix时间戳，单位毫秒。
     * @param endTime   审批实例结束时间，Unix时间戳，单位毫秒。
     */
    List<String> getInstanceIds_all(String access_token, String processCode, long startTime, long endTime, Map extInfo);

    /**
     * 获取全部架构内全部部门 detail
     */
    List<Map> getDepartmentDetail_all(String access_token);

    /**
     * 获取全部架构内全部部门 ID
     */
    List<Long> getDepartmentId_all(String access_token);
}

