package com.malk.service.dingtalk.impl;

import com.malk.Util.UtilMap;
import com.malk.server.dingtalk.DDR;
import com.malk.service.dingtalk.DDClient_Attendance;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class DDClientImpl_Attendance implements DDClient_Attendance {

    /**
     * 获取打卡结果
     */
    @Override
    public List<Map> listAttendanceResult(String access_token, String[] userIdList, String workDateFrom, String workDateTo, Number offset, Number limit, boolean isI18n) {
        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("userIdList, workDateFrom, workDateTo, offset, limit, isI18n", userIdList, workDateFrom, workDateTo, offset, limit, isI18n);
        return DDR.doPost("https://oapi.dingtalk.com/attendance/list", null, param, body).getRecordresult();
    }

    /**
     * 获取打卡详情
     */
    @Override
    public List<Map> listAttendanceRecord(String access_token, List userIds, String checkDateFrom, String checkDateTo, boolean isI18n) {
        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("userIds, checkDateFrom, checkDateTo, isI18n", userIds, checkDateFrom, checkDateTo, isI18n);
        return DDR.doPost("https://oapi.dingtalk.com/attendance/listRecord", null, param, body).getRecordresult();
    }

    /**
     * 获取打卡详情
     */
    @Override
    public boolean uploadAttendanceRecord(String access_token, String userId, String deviceName, String deviceId, String photoUrl, long userCheckTime) {
        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("userid, device_name, device_id, photo_url, user_check_time", userId, deviceName, deviceId, photoUrl, userCheckTime);
        return DDR.doPost("https://oapi.dingtalk.com/topapi/attendance/record/upload", null, param, body).isSuccess();
    }
}
